diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/FloatSliderComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/FloatSliderComponent.java
new file mode 100644
index 000000000..4fba680e7
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/FloatSliderComponent.java
@@ -0,0 +1,101 @@
+package net.minecraft.client.gui.options.components;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.SliderElement;
+import net.minecraft.client.render.window.CursorShape;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.function.Consumer;
+import java.util.function.Function;
+import java.util.function.Supplier;
+
+public class FloatSliderComponent
+    extends ButtonComponent
+{
+    private final Supplier<Float> getter;
+    private final Consumer<Float> setter;
+    private final float defaultValue;
+    private final float minValue;
+    private final float maxValue;
+    private final SliderElement slider;
+    private final Function<Float, String> formatter;
+
+    public FloatSliderComponent(String translationKey, float defaultValue, float minValue, float maxValue, Supplier<Float> getter, Consumer<Float> setter, Function<Float, String> formatter, @Nullable String tooltipTranslationKey) {
+        super(translationKey, tooltipTranslationKey);
+
+        this.getter = getter;
+        this.setter = setter;
+        this.defaultValue = defaultValue;
+        this.minValue = minValue;
+        this.maxValue = maxValue;
+        this.formatter = formatter;
+        this.slider = new SliderElement(0, 0, 0, 150, 20, formatter.apply(getter.get()), MathHelper.unlerp(minValue, maxValue, getter.get()));
+    }
+
+    public FloatSliderComponent(String translationKey, float defaultValue, float minValue, float maxValue, Supplier<Float> getter, Consumer<Float> setter, Function<Float, String> formatter) {
+        this(translationKey, defaultValue, minValue, maxValue, getter, setter, formatter, null);
+    }
+
+    @Override
+    protected void buttonClicked(int mouseButton, int x, int y, int width, int height, int relativeMouseX, int relativeMouseY) {
+        this.slider.mouseClicked(mc, this.slider.xPosition + relativeMouseX, this.slider.yPosition + relativeMouseY);
+        applySliderValue();
+    }
+
+    @Override
+    protected void buttonDragged(int x, int y, int width, int height, int relativeMouseX, int relativeMouseY) {
+        this.slider.mouseDragged(mc, this.slider.xPosition + relativeMouseX, this.slider.yPosition + relativeMouseY);
+        applySliderValue();
+    }
+
+    @Override
+    protected void buttonReleased(int mouseButton, int x, int y, int width, int height, int relativeMouseX, int relativeMouseY) {
+        this.slider.mouseReleased(this.slider.xPosition + relativeMouseX, this.slider.yPosition + relativeMouseY);
+        applySliderValue();
+    }
+
+    private void applySliderValue() {
+        float value = (float) MathHelper.lerp(minValue, maxValue, this.slider.sliderValue);
+        this.setter.accept(value);
+        onChanged();
+    }
+
+    @Override
+    protected void renderButton(int x, int y, int relativeButtonX, int relativeButtonY, int buttonWidth, int buttonHeight, int relativeMouseX, int relativeMouseY) {
+        super.renderButton(x, y, relativeButtonX, relativeButtonY, buttonWidth, buttonHeight, relativeMouseX, relativeMouseY);
+
+        this.slider.xPosition = x + relativeButtonX;
+        this.slider.yPosition = y + relativeButtonY;
+        this.slider.width = buttonWidth;
+        this.slider.height = buttonHeight;
+
+        this.slider.drawButton(mc, x + relativeMouseX, y + relativeMouseY);
+
+        if (relativeMouseX >= relativeButtonX && relativeMouseX < relativeButtonX + buttonWidth && relativeMouseY >= relativeButtonY && relativeButtonY < relativeButtonY + buttonHeight) {
+            mc.currentScreen.setDesiredCursor(CursorShape.HAND);
+        }
+    }
+
+    @Override
+    public void resetValue() {
+        this.setter.accept(this.defaultValue);
+        this.slider.sliderValue = MathHelper.unlerp(minValue, maxValue, this.defaultValue);
+        onChanged();
+    }
+
+    @Override
+    public void init(Minecraft mc) {
+        this.slider.sliderValue = MathHelper.unlerp(minValue, maxValue, this.getter.get());
+        onChanged();
+    }
+
+    private void onChanged() {
+        this.slider.displayString = this.formatter.apply(this.getter.get());
+    }
+
+    @Override
+    public boolean isDefault() {
+        return Math.abs(this.getter.get() - this.defaultValue) < 0.0001f;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index c9d530942..5d5ba8232 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -60,7 +60,6 @@ public abstract class OptionsPages {
     public static OptionsPage LANGUAGE;
     public static OptionsPage SEARCH;
     public static OptionsPage DEBUG;
-    public static OptionsPage HIDDEN;
 
     public static OptionsPage register(OptionsPage page) {
         OptionsPageRegistry.getInstance().register(page);
@@ -83,6 +82,7 @@ public abstract class OptionsPages {
             .withComponent(new OptionsCategory("gui.options.page.general.category.user_interface")
                 .withComponent(new ShortcutComponent("gui.options.page.general.button.edit_hud", () -> mc.displayScreen(new ScreenHudEditor(mc.currentScreen))))
                 .withComponent(new ToggleableOptionComponent<>(GameSettings.GUI_SCALE).applyOnRelease())
+                .withComponent(new FloatOptionComponent(GameSettings.SCREEN_PADDING, 0, 100))
                 .withComponent(new TooltipPickerComponent(GameSettings.TOOLTIP_STYLE))
                 .withComponent(new ToggleableOptionComponent<>(GameSettings.FONT))
                 .withComponent(new ToggleableOptionComponent<>(GameSettings.chatVisibility))
diff --git a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
index d2dd33b26..42f2861ee 100644
--- a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -9,6 +9,7 @@ import net.minecraft.client.discord.RichPresenceHandlerThread;
 import net.minecraft.client.enums.MusicFrequency;
 import net.minecraft.client.enums.SelectedSoundtrack;
 import net.minecraft.client.gui.TooltipElement;
+import net.minecraft.client.gui.hud.component.HudComponent;
 import net.minecraft.client.gui.hud.component.HudComponents;
 import net.minecraft.client.gui.options.ScreenOptions;
 import net.minecraft.client.input.InputDevice;
@@ -134,7 +135,7 @@ public final class GameSettings {
     public static final @NotNull OptionBoolean TRANSPARENCY_DEPTH_CHECK = register(new OptionBoolean("transparencyDepthCheck", true));
     public static final @NotNull OptionEnum<ParticlesQuality> PARTICLES_QUALITY = register(new OptionEnum<>("particleQuality", ParticlesQuality.class, ParticlesQuality.ALL));
     public static final @NotNull OptionRange PARTICLES_CAP = register(new OptionRange("particleCap", 50000, 1000, 100000));
-    public static final @NotNull OptionRange PARTICLE_RENDER_DISTANCE = register(new OptionRange("particleRenderDistance", 12, 1, 24)
+    public static final @NotNull OptionRange PARTICLE_RENDER_DISTANCE = register(new OptionRange("particleRenderDistance", 8, 1, 24)
         .addOnChangeCallback((mc, option) -> {
             if (mc.currentScreen instanceof ScreenOptions) {
                 ScreenOptions.queueReload = true;
@@ -271,12 +272,22 @@ public final class GameSettings {
             }
         })
         .withDisplayStringProvider((mc, i18n, option) -> {
+            for (HudComponent component : HudComponents.INSTANCE.getComponents()) {
+                if (component.getScaleOverride() > 0) {
+                    return i18n.translateKey("options.guiScale.disabled");
+                }
+            }
             if (option.value == 0) {
                 return i18n.translateKey("options.guiScale.auto");
             } else {
                 return option.value + "x";
             }
         }));
+    public static final @NotNull OptionFloat SCREEN_PADDING = register(new OptionFloat("screenPadding", 2.0f)
+        .withDisplayStringProvider((mc, i18n, option) -> {
+            int pixels = (int) option.value.floatValue();
+            return pixels + "px";
+        }));
     public static final @NotNull OptionInteger OVERLAY_MODE = register(new OptionInteger("overlayMode", 0));
     public static final @NotNull OptionInteger ROTATION_OVERLAY_MODE = register(new OptionInteger("rotationOverlayMode", 0));
     public static final @NotNull OptionEnum<TextureAnimation> TEXTURE_ANIMATIONS = register(new OptionEnum<>("animations", TextureAnimation.class, TextureAnimation.CUSTOM)
@@ -292,6 +303,7 @@ public final class GameSettings {
             mc.renderGlobal.allChanged();
         }));
     public static final @NotNull OptionInteger PLAYER_LIST_POSITION = register(new OptionInteger("playerListPosition", 2));
+    public static final @NotNull OptionInteger LAST_CREATIVE_INVENTORY_PAGE = register(new OptionInteger("lastCreativeInventoryPage", 0));
     public static final @NotNull OptionFloat COLOR_CORRECTION = register(new OptionFloat("colorCorrection", 0.5f));
     public static final @NotNull OptionBoolean SNEAK_TOGGLE = register(new OptionBoolean("sneakToggle", false));
     public static final @NotNull OptionFloat AUTOSAVE_TIMER = register(new OptionFloat("autosaveTimer", 0.04166666666F)
@@ -320,7 +332,7 @@ public final class GameSettings {
             return option.toOptionsString();
         }));
     public static final @NotNull OptionEnum<RenderScale> RENDER_SCALE = register(new OptionEnum<>("renderScale", RenderScale.class, RenderScale.SCALE_100));
-    public static final @NotNull OptionFloat HEAT_HAZE = register(new OptionFloat("heatHaze", 0));
+    public static final @NotNull OptionFloat HEAT_HAZE = register(new OptionFloat("heatHaze", 50));
     public static final @NotNull OptionBoolean ALPHA_MENU = register(new OptionBoolean("old", false));
     public static final @NotNull OptionBoolean ENABLE_ITEM_CLUMPING = register(new OptionBoolean("enableItemClumping", true));
     public static final @NotNull OptionEnum<DescriptionPromptEnum> ITEM_DESCRIPTIONS = register(new OptionEnum<>("itemDescriptions", DescriptionPromptEnum.class, DescriptionPromptEnum.PROMPT));
@@ -479,19 +491,19 @@ public final class GameSettings {
     public static final @NotNull OptionBoolean HIDE_HELD_ITEM_COUNT = register(new OptionBoolean("hideHeldItemCount", true));
 
     public static final @NotNull OptionEnum<ArmorHiddenState> HIDE_HELMET_BAR = register(
-        new OptionEnum<>("hideHelmetBar", ArmorHiddenState.class, ArmorHiddenState.NEVER)
+        new OptionEnum<>("hideHelmetBar", ArmorHiddenState.class, ArmorHiddenState.WHEN_NOT_WEARING)
             .setIsSlider(true)
     );
     public static final @NotNull OptionEnum<ArmorHiddenState> HIDE_CHESTPLATE_BAR = register(
-        new OptionEnum<>("hideChestplateBar", ArmorHiddenState.class, ArmorHiddenState.NEVER)
+        new OptionEnum<>("hideChestplateBar", ArmorHiddenState.class, ArmorHiddenState.WHEN_NOT_WEARING)
             .setIsSlider(true)
     );
     public static final @NotNull OptionEnum<ArmorHiddenState> HIDE_LEGGINGS_BAR = register(
-        new OptionEnum<>("hideLeggingsBar", ArmorHiddenState.class, ArmorHiddenState.NEVER)
+        new OptionEnum<>("hideLeggingsBar", ArmorHiddenState.class, ArmorHiddenState.WHEN_NOT_WEARING)
             .setIsSlider(true)
     );
     public static final @NotNull OptionEnum<ArmorHiddenState> HIDE_BOOTS_BAR = register(
-        new OptionEnum<>("hideBootsBar", ArmorHiddenState.class, ArmorHiddenState.NEVER)
+        new OptionEnum<>("hideBootsBar", ArmorHiddenState.class, ArmorHiddenState.WHEN_NOT_WEARING)
             .setIsSlider(true)
     );
 
@@ -519,7 +531,15 @@ public final class GameSettings {
             .setIsSlider(true)
     );
     public static final @NotNull OptionEnum<HorizontalTextAlignment> HORIZONTAL_LOG_TEXT_ALIGNMENT = register(
-        new OptionEnum<>("horizontalLogTextAlignment", HorizontalTextAlignment.class, HorizontalTextAlignment.LEFT)
+        new OptionEnum<>("horizontalLogTextAlignment", HorizontalTextAlignment.class, HorizontalTextAlignment.RIGHT)
+            .setIsSlider(true)
+    );
+    public static final @NotNull OptionEnum<HorizontalTextAlignment> HORIZONTAL_CHAT_TEXT_ALIGNMENT = register(
+        new OptionEnum<>("horizontalChatTextAlignment", HorizontalTextAlignment.class, HorizontalTextAlignment.LEFT)
+            .setIsSlider(true)
+    );
+    public static final @NotNull OptionEnum<HorizontalTextAlignment> HORIZONTAL_SUBTITLE_TEXT_ALIGNMENT = register(
+        new OptionEnum<>("horizontalSubtitleTextAlignment", HorizontalTextAlignment.class, HorizontalTextAlignment.RIGHT)
             .setIsSlider(true)
     );
     public static final @NotNull OptionEnum<VerticalTextAlignment> VERTICAL_INFO_TEXT_ALIGNMENT = register(
@@ -530,6 +550,14 @@ public final class GameSettings {
         new OptionEnum<>("verticalLogTextAlignment", VerticalTextAlignment.class, VerticalTextAlignment.TOP)
             .setIsSlider(true)
     );
+    public static final @NotNull OptionEnum<VerticalTextAlignment> VERTICAL_CHAT_TEXT_ALIGNMENT = register(
+        new OptionEnum<>("verticalChatTextAlignment", VerticalTextAlignment.class, VerticalTextAlignment.BOTTOM)
+            .setIsSlider(true)
+    );
+    public static final @NotNull OptionEnum<VerticalTextAlignment> VERTICAL_SUBTITLE_TEXT_ALIGNMENT = register(
+        new OptionEnum<>("verticalSubtitleTextAlignment", VerticalTextAlignment.class, VerticalTextAlignment.BOTTOM)
+            .setIsSlider(true)
+    );
 
     //KeyBind Options
     public static final @NotNull KeyBinding KEY_ATTACK = register(new KeyBinding("key.attack").setDefault(InputDevice.mouse, 0));
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionGuiScaleOverride.java b/game/client/src/main/java/net/minecraft/client/option/OptionGuiScaleOverride.java
new file mode 100644
index 000000000..d75a8cb59
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionGuiScaleOverride.java
@@ -0,0 +1,83 @@
+package net.minecraft.client.option;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.ScaledResolution;
+import net.minecraft.core.lang.I18n;
+import org.jetbrains.annotations.NotNull;
+
+/**
+ * Per-instance scale override for HUD components. Behaves much like
+ * {@link OptionGuiScale}, but with a "Disabled" entry instead of "Auto"; when
+ * {@code value == 0} the component should fall back to the global GUI scale.
+ *
+ * <p>Instances of this class are intentionally NOT registered through
+ * {@link GameSettings#register}: each HUD Component
+ * owns its own instance and serializes it as part of its own settings string.
+ */
+public class OptionGuiScaleOverride extends OptionToggleable<Integer> {
+    public OptionGuiScaleOverride() {
+        super("guiScaleOverride", 0, new Integer[1]);
+    }
+
+    @Override
+    public void toggle() {
+        toggle(1);
+    }
+
+    @Override
+    public void toggle(int delta) {
+        int size = size();
+        setValueWithIndex((getValueIndex() + delta) % size);
+    }
+
+    @Override
+    public int getValueIndex() {
+        int max = size();
+        if (this.value <= 0 || this.value >= max) {
+            return 0;
+        }
+        return max - this.value;
+    }
+
+    @Override
+    public void setValueWithIndex(int i) {
+        if (i != 0) {
+            this.value = size() - i;
+        } else {
+            this.value = 0;
+        }
+    }
+
+    @Override
+    public int size() {
+        Minecraft mc = Minecraft.getMinecraft();
+        int width = mc.gameWindow.getWidthScreenCoords();
+        int height = mc.gameWindow.getHeightScreenCoords();
+        return ScaledResolution.getMaxScale(width, height);
+    }
+
+    @Override
+    public boolean isSlider() {
+        return true;
+    }
+
+    @Override
+    public void fromOptionsString(@NotNull String string) {
+        try {
+            this.value = Integer.parseInt(string);
+        } catch (NumberFormatException e) {
+            this.value = 0;
+        }
+    }
+
+    @Override
+    public @NotNull String getDisplayString() {
+        if (this.displayStringProvider != null) {
+            return this.displayStringProvider.getDisplayString(Minecraft.getMinecraft(), I18n.getInstance(), this);
+        }
+        if (this.value <= 0) {
+            return I18n.getInstance().translateKey("options.guiScaleOverride.disabled");
+        }
+        return this.value + "x";
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/ClientFireOverlayHelper.java b/game/client/src/main/java/net/minecraft/client/render/ClientFireOverlayHelper.java
index ee6f726ce..4a0d2a754 100644
--- a/game/client/src/main/java/net/minecraft/client/render/ClientFireOverlayHelper.java
+++ b/game/client/src/main/java/net/minecraft/client/render/ClientFireOverlayHelper.java
@@ -22,4 +22,11 @@ public final class ClientFireOverlayHelper {
 
         return "minecraft:block/fire";
     }
+    public static boolean usesSulfuricFireOverlay(final @Nullable Entity entity) {
+        if (entity == null || entity.activeFireBlock == null) {
+            return false;
+        }
+        return entity.activeFireBlock == Blocks.FIRE_SULFURIC
+            || entity.activeFireBlock.hasTag(BlockTags.SULFURIC_FIRE_OVERLAY_SOURCE);
+    }
 }
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java b/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
index c77be5e92..ba93e9343 100644
--- a/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
@@ -21,8 +21,8 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.world.pos.TilePos;
 import org.joml.Math;
 
@@ -251,7 +251,11 @@ public class ItemRenderer {
 
         texture.parentAtlas.bind();
 
-        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 0.85F);
+        if (ClientFireOverlayHelper.usesSulfuricFireOverlay(this.mc.thePlayer)) {
+            GLRenderer.setColor4f(1.0F, 0.70F, 0.24F, 0.85F);
+        } else {
+            GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 0.85F);
+        }
         GLRenderer.enableState(State.BLEND);
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/Lighting.java b/game/client/src/main/java/net/minecraft/client/render/Lighting.java
index aa4f2e796..9a8f53aa2 100644
--- a/game/client/src/main/java/net/minecraft/client/render/Lighting.java
+++ b/game/client/src/main/java/net/minecraft/client/render/Lighting.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render;
 
-import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.renderer.GLRenderer;
 import org.jetbrains.annotations.NotNull;
 import org.joml.Math;
@@ -16,10 +15,12 @@ public final class Lighting {
         GLRenderer.globalGetLight0().enabled = false;
         GLRenderer.globalGetLight1().enabled = false;
 //        glDisable(GL_COLOR_MATERIAL);
+        GLRenderer.setLightMapStrength(0f);
     }
 
     public static void enableInventoryLight() {
         enableLight(0.4f, 0.5f);
+        GLRenderer.setLightMapStrength(0f);
         GLRenderer.globalGetNormalTransformMatrix()
             .rotateY(Math.toRadians(-30.0f))
             .rotateX(Math.toRadians(155.0f))
@@ -36,6 +37,7 @@ public final class Lighting {
         GLRenderer.globalGetLight0().enabled = true;
         GLRenderer.globalGetLight1().enabled = true;
 //        glEnable(GL_COLOR_MATERIAL);
+        GLRenderer.setLightMapStrength(1f);
 //        glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
 
         GLRenderer.globalGetLight0().position.set(0.2f, 1.0f, -0.7f).normalize();
diff --git a/game/client/src/main/java/net/minecraft/client/render/LightmapHelper.java b/game/client/src/main/java/net/minecraft/client/render/LightmapHelper.java
index ced5da4e6..3854739bc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/LightmapHelper.java
+++ b/game/client/src/main/java/net/minecraft/client/render/LightmapHelper.java
@@ -10,6 +10,7 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ScreenPhotoMode;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.option.enums.LightmapStyle;
+import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.util.helper.Textures;
 import net.minecraft.client.util.helper.Buffer;
 import net.minecraft.client.world.WorldClient;
diff --git a/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java b/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
index 79a2c9bfa..0daeb80e6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
+++ b/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
@@ -18,8 +18,9 @@ import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.client.render.tessellator.TessellatorParticleShader;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLogicFire;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.material.MaterialGas;
+import net.minecraft.core.block.material.MaterialLiquid;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
@@ -262,7 +263,8 @@ public final class ParticleEngine {
     public void destroy(@NotNull TilePosc blockPos, int id, int data) {
         if (GameSettings.PARTICLES_QUALITY.value == ParticlesQuality.NONE) return;
         Block<?> block = Blocks.blocksList[id];
-        if (block == null || block.getLogic() instanceof BlockLogicFire) return;
+        final var material = block.getMaterial();
+        if (material instanceof MaterialGas || material instanceof MaterialLiquid) return;
         int amount = GameSettings.PARTICLES_QUALITY.value == ParticlesQuality.REDUCED ? 2 : 4;
 
         AABBdc bounds = block.getLogic().getBoundsFromState(this.world, blockPos);
diff --git a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
index 66736be6b..fd5b5ea7f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -663,6 +663,7 @@ public class WorldRenderer {
         TextureRegistry.worldAtlas.bind();
 
         Debug.change("terrain");
+        Lighting.enableLight();
         GLRenderer.pushFrame();
         GLRenderer.setDepthFunc(CompareFunc.LESS_EQUAL);
         GL41.glActiveTexture(GL41.GL_TEXTURE2);
@@ -670,7 +671,6 @@ public class WorldRenderer {
         GL41.glActiveTexture(GL41.GL_TEXTURE3);
         TextureRegistry.worldAtlas.layerTextureMap.get("maskColor").bind();
         GL41.glActiveTexture(GL41.GL_TEXTURE0);
-        Lighting.enableLight();
         GLRenderer.setShader(Shaders.TERRAIN);
         GLRenderer.globalSetUniforms(Shaders.TERRAIN);
         this.lightmapHelper.enableLightmapRendering();
@@ -686,9 +686,12 @@ public class WorldRenderer {
         particleEngine.renderLitParticles(this.mc.activeCamera, partialTicks);
         Lighting.disable();
         this.fogManager.setupFog(FogManager.FOG_MODE_NORMAL, this.farPlaneDistance, partialTicks, GLRenderer.getFogState());
+        GLRenderer.pushFrame();
+        GLRenderer.setLightMapStrength(1f);
         this.mc.renderer.beginRenderParticles(partialTicks);
         particleEngine.renderParticles(this.mc.activeCamera, partialTicks);
         this.mc.renderer.endRenderParticles(partialTicks);
+        GLRenderer.popFrame();
 
         this.lightmapHelper.disableLightmapRendering();
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 5fe4cd627..fb11ab398 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -383,7 +383,7 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelGenericButton<>(Blocks.BUTTON_GLOOMSTONE, "minecraft:block/button/stone/gloomstone"));
         addDispatch(new BlockModelGenericButton<>(Blocks.BUTTON_SANDSTONE, "minecraft:block/button/stone/sandstone"));
         addDispatch(new BlockModelGenericButton<>(Blocks.BUTTON_BRIMSTONE, "minecraft:block/button/stone/brimstone"));
-        addDispatch(new BlockModelGenericButton<>(Blocks.BUTTON_PLANKS, "minecraft:block/button/planks/oak"));
+        addDispatch(new BlockModelGenericButton<>(Blocks.BUTTON_PLANKS_OAK, "minecraft:block/button/planks/oak"));
         addDispatch(new BlockModelGenericButtonPainted<>(Blocks.BUTTON_PLANKS_PAINTED));
 
         addDispatch(new BlockModelGenericLever<>(Blocks.LEVER_COBBLE_STONE).render3D(false));
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericMatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericMatcher.java
index f5eb59693..cd0474632 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericMatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericMatcher.java
@@ -1,16 +1,21 @@
 package net.minecraft.client.render.block.model.generic;
 
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicAxisAligned;
+import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.useless.dragonfly.models.block.StaticBlockModel;
 
 import java.util.Random;
 
-public class BlockModelGenericMatcher<T extends BlockLogic> extends BlockModelGenericAxis<T> {
+public class BlockModelGenericMatcher<T extends BlockLogic> extends BlockModelGeneric<T> {
     public final @NotNull StaticBlockModel[] models = new StaticBlockModel[4];
     public final Random random = new Random();
     public BlockModelGenericMatcher(@NotNull Block<T> block, @NotNull String baseKey) {
@@ -20,6 +25,23 @@ public class BlockModelGenericMatcher<T extends BlockLogic> extends BlockModelGe
         }
     }
 
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        Axis axis = BlockLogicAxisAligned.metaToAxis(worldSource.getBlockData(tilePos));
+        switch (axis) {
+            case X -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 1, 3, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case Y -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case Z -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 1, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+        }
+        return false;
+    }
+
     @Override
     public @NotNull StaticBlockModel getModel(@NotNull WorldSource source, @NotNull TilePosc tilePosc) {
         this.random.setSeed(getPositionalSeed(tilePosc));
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericSlab.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericSlab.java
index 39393183f..5d1bcca76 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericSlab.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericSlab.java
@@ -2,7 +2,13 @@ package net.minecraft.client.render.block.model.generic;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import net.minecraft.core.world.type.WorldType;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.useless.dragonfly.data.block.BlockModelData;
 import org.useless.dragonfly.models.block.StaticBlockModel;
 
@@ -23,4 +29,34 @@ public class BlockModelGenericSlab<T extends BlockLogic> extends BlockModelGener
             default -> this.staticModel;
         };
     }
+
+    private final @NotNull TilePos queryPos = new TilePos();
+    @Override
+    public boolean cullSide(@NotNull WorldSource worldSource, @NotNull TilePosc blockPos, @Nullable Direction direction) {
+        int data = worldSource.getBlockData(blockPos);
+        boolean upperFaceVisible = (data & 0b11) == 1 || (data & 0b11) == 2;
+        boolean lowerFaceVisible = (data & 0b11) == 0 || (data & 0b11) == 1;
+
+        if (direction != null) {
+            // Cull world ceiling and floors
+            WorldType worldType = worldSource.getWorldType();
+            if (worldType.hasCeiling() && direction == Direction.UP && blockPos.y() >= worldType.getMaxY(worldSource) && upperFaceVisible) {
+                return true;
+            } else if (direction == Direction.DOWN && blockPos.y() <= worldType.getMinY(worldSource) && lowerFaceVisible) {
+                return true;
+            }
+
+            TilePos shifted = blockPos.add(direction, this.queryPos);
+            Block<?> b = worldSource.getBlockType(shifted);
+            if (b == this.block) {
+                int otherData = worldSource.getBlockData(shifted);
+                if (otherData == 1) return true;
+                int selfData = worldSource.getBlockData(blockPos);
+                return selfData == otherData;
+            } else {
+                return worldSource.isBlockOpaqueCube(shifted);
+            }
+        }
+        return false;
+    }
 }
